#ifndef CLIENT_H
#define CLIENT_H

#include "../engine/Mesh.h"
#include "../math/Vector3D.h"
#include "../world/Chunk.h"
#include "../engine/Texture.h"

using namespace std;

class Client
{
public:
    static void start();
    static void stop();
    static Client& get();
    
    virtual ~Client();
private:
    Client();
    static Client* instance;
    
    static const int KEY_LEFT = 0;
    static const int KEY_RIGHT = 1;
    static const int KEY_UP = 2;
    static const int KEY_DOWN = 3;
    static const int KEY_JUMP = 4;
    static const int KEY_SNEAK = 5;
    
    static const int KEY_CAM_LEFT = 6;
    static const int KEY_CAM_RIGHT = 7;
    static const int KEY_CAM_UP = 8;
    static const int KEY_CAM_DOWN = 9;

    void tick();
    void renderTick(float lag);
    
    Texture texture;
    Chunk chunk;
    
    Vector3D position;
    float lengthAngle = 0;
    float widthAngle = 0;
};

#endif

